<!DOCTYPE html>
<html lang="en">
<head>
     <meta charset="UTF-8">
     <meta http-equiv="X-UA-Compatible" content="IE=edge">
     <meta name="viewport" content="width=device-width, initial-scale=1.0">
     <title>Task 30.35_Sign-up Form</title>

     <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
     <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
     <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css" />
</head>
<body>
     <div class="container">
          <div class="row">
               <div class="col-sm-6 jumbotron signup-form mx-auto">
                    <div class="form-group">
                         <h2>Sign Up</h2>
                    </div>
                    <div class="form-group">
                         <p class="hint-text">Please fill in this form to create account</p>
                    </div>
                    <div class="form-group">
                         <hr>
                    </div>
                    <div class="form-group">
                         <div class="row">
                              <div class="col">
                                   <input type="text" class="form-control" id="inp-first-name" placeholder="First Name">
                             </div>
                             <div class="col">
                              <input type="text" class="form-control" id="inp-last-name" placeholder="Last Name">
                              </div>
                         </div>
                    </div>
                    <div class="form-group">
                         <input type="email" class="form-control" id="inp-email" placeholder="Email">
                    </div>
                    <div class="form-group">
                         <input type="password" class="form-control" id="inp-password" placeholder="Password">
                    </div>
                    <div class="form-group">
                         <input type="password" class="form-control" id="inp-comfirm-password" placeholder="Confirm Password">
                    </div>
                    <div class="form-group">
                         <input type="checkbox" id="check-confirm-accept"> I accept the
                         <a href="#">Terms of Use</a> &amp;
                         <a href="#">Privacy Policy</a>
                         <p id="p-agree-feedback" class="invalid-feedback">You must accept before submitting.</p>
                    </div>
                    <div class="form-group">
                         <button id="btn-sign-up" class="btn btn-primary btn-lg">Sign Up</button>
                    </div>
               </div>
          </div>
     </div>
</body>

<script>
     $(document).ready(function(){
          "use strict";
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
     var gElementFirstName = $("#inp-first-name");
     var gElementLastName = $("#inp-last-name");
     var gElementEmail = $("#inp-email");
     var gElementPassword = $("#inp-password");
     var gElementConfirmPassword = $("#inp-comfirm-password");
     var gElementAccept = $("#check-confirm-accept");
  /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
     $("#btn-sign-up").on("click", onBtnSignUpClick);
  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
     //hàm xử lý sự kiện khi nút sign up được nhấn 
     function  onBtnSignUpClick(){
          var vUserObj = {
               firstname: " ",
               lastname: "", 
               email: "", 
               password: "", 
               confirmPassword: "", 
               iAccept: "", 

          }

          //bước 1: thu thập dữ liệu 
               thuThapDuLieu(vUserObj);
          //bước 2: kiểm tra dữ liêuj 
               var vCheck = kiemTraDuLieu(vUserObj);
               if(vCheck){
                     //bước 3: hiển thị dữ liệu 
                    hienThiThongTinUser(vUserObj);
               }
         
     }
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/

  //hàm xử lý việu thu thập dữ liệu 
  function thuThapDuLieu(paramUserObj){
   paramUserObj.firstname =gElementFirstName.val().trim();
   paramUserObj.lastname =gElementLastName.val().trim();
   paramUserObj.email = gElementEmail.val().trim();
   paramUserObj.password = gElementPassword.val().trim();
   paramUserObj.confirmPassword = gElementConfirmPassword.val().trim();
   paramUserObj.iAccept = gElementAccept.is(":checked");
  }

  //hàm kiểm tra dữ liệu
  function kiemTraDuLieu(paramUserObj){
     var vRegexStr = /^[^\s@]+@[^\s@]+\.[^\s@]+$/;
     if(paramUserObj.firstname == ""){
          console.log("Bạn chưa nhập Username!!!");
          return false;
     }
     if(paramUserObj.lastname == ""){
          console.log("Bạn chưa nhập Lastname!!!");
          return false;
     }
     if(paramUserObj.email == ""){
          console.log("Bạn chưa nhập Email!!!");
          return false;
     }
     if(!vRegexStr.test(paramUserObj.email)){
          console.log("Email không hợp lệ!!!");
          return false;
     }
     if(paramUserObj.password == ""){
          console.log("Bạn chưa nhập Password!!!");
          return false;
     }
     if(paramUserObj.password != paramUserObj.confirmPassword){
          console.log("Confirm Password của bạn không khớp với Password ở trên!!!");
          return false;
     }
     if(!paramUserObj.iAccept){
          $("#p-agree-feedback").css("display", "block");
          console.log("You must accept before submitting!!!");
          return falsel;
     }else{
          $("#p-agree-feedback").css("display", "none")
     }
     return true;
  }

  //hàm xử lý việc hiển thị thông tin
  function hienThiThongTinUser(paramUserObj){
     console.log("Firstname: " + paramUserObj.firstname); 
     console.log("Lastname: " + paramUserObj.lastname); 
     console.log("Email: " + paramUserObj.email); 
     console.log("Password: " + paramUserObj.password); 
     console.log("Confirm Password: " + paramUserObj.confirmPassword); 
     console.log("I Accept: " + paramUserObj.iAccept); 
  }

});
</script>
</html>